# Discrete Lehmann representation

## Main Module

```@autodocs
Modules = [Lehmann]
```

## Spectral functions

This module defines the kernels of Lehmann representation for different particles and symmetries.

```@autodocs
Modules = [Lehmann.Spectral]
```

## Sample Green's Function Builder

This module provides subroutines to generate Green's function samples. 

```@autodocs
Modules = [Lehmann.Sample]
```

## Discrete DLR builder

This module provides a DLR builder based on the conventional QR algorithm. 

```@autodocs
Modules = [Lehmann.Discrete]
```

## Functional DLR builder

This module provides a DLR builder based on a functional QR algorithm. It can generate DLR at extremely low temperature.

```@autodocs
Modules = [Lehmann.Functional]
```

## Utility

This module provides the utility subroutines for other DLR modules.

```@autodocs
Modules = [Lehmann.Interp]
```